<template>
  <figure class="chartTile" v-on:click="$emit('onTileClick')">
    <section class="chartTile__inner" v-if="isReady">
      <section class="chartTile__cover" v-bind:style="{ backgroundImage: 'url(' + item.image + ')' }"></section>
      <section class="chartTile__meta">
        <ul class="chartTile__trackList">
          <li class="chartTile__track"
            v-for="(track, index) in item.tracks"
            v-bind:key="index"
            v-on:click.stop="$emit('onTrackClick', track.id)">
            <section class="chartTile__track__number">{{index + 1}}</section>
            <section class="chartTile__track__detail">
              <section class="chartTile__track__title">{{track.title}}</section>
              <section class="chartTile__track__duration">{{track.duration | trackTime}}</section>
            </section>
          </li>
          <li class="chartTile__track dots">
            <span>...</span>
          </li>
        </ul>
        <section class="chartTile__info">
          <section class="chartTile__title">{{item.header}}</section>
          <section class="chartTile__artist" v-if="item.subheader">
            <section class="chartTile__artist__name">{{item.subheader}}</section>
          </section>
        </section>
      </section>
    </section>
  </figure>
</template>

<script>
import Vue from 'vue';
import Component from 'vue-class-component';

@Component({
  props: {
    item: Object,
  },
})
export default class ChartTile extends Vue {
  get isReady() {
    return Boolean(this.$props.item && this.$props.item.image && this.$props.item.header);
  }
}
</script>

<style lang="stylus">
.chartTile
  position relative
  min-width 514px
  height 222px
  margin 0 16px 0 0
  display flex
  flex-direction row
  border-radius 4px
  overflow hidden
  box-shadow 0 0 3px rgba(0,0,0,.05)
  background-color #1c212c
  cursor pointer
  &:hover
    box-shadow 0 0 8px rgba(0,0,0,.4)

  &__inner
    width 100%
    display flex
    flex-direction row
    flex 1

  &__cover
    width 222px
    height 222px
    background-size cover
    background-position center 
    background-repeat no-repeat

  &__meta
    padding 0
    display flex
    flex-direction column
    flex 1

  &__trackList
    margin 0
    padding 8px 0 0 0
    list-style none
    
  &__track
    margin 0 !important
    padding 6px 12px 4px 12px
    display flex
    align-items center
    color #8f94a0
    font-size 12px
    line-height 1.2
    &:hover
      background rgba(255,255,255,.05)
    &.dots
      height 5px
      max-height 5px
      padding 0 12px
      cursor default
      &:hover
        background-color transparent

    &__number
      margin-right 12px

    &__detail
      width 100%
      display flex
      flex-direction row
      justify-content space-between

    &__title
      display block
      max-width 210px
      overflow hidden
      text-overflow ellipsis
      white-space nowrap
      font-size 12px
      font-weight 500
      line-height 1

    &__duration
      color #565c69
      font-size 12px
      font-weight bold
      line-height 1

  &__info
    display flex
    flex-direction column
    justify-content center
    flex 1
    padding 8px 16px

  &__title
    padding-bottom 8px
    font-size 22px
    font-weight 1.1
    font-family 'Encode Sans', sans-serif
    line-height 1.1

  &__artist__name
    color #565c69
    font-size 12px
    font-weight bold
</style>

